# Contributing
KTweak is open to external collaboration, suggestions, and ideas. In order to effectively contribute to the project, ensure you follow the guidelines below before suggesting a change.

# Pull Requests
* Ensure your proposed changes abide by the Code of Conduct
* Provide substantial logic or evidence that your change is beneficial
* Match the code style of the current project in your commits

# Code of Conduct
## Standards
All suggested changes must abide by the following regulations.

* No proprietary specific tweaks. KTweak is designed to be a universal module. Please do not include OEM and custom kernel specific tunings in your suggestions.
* All changes must be well-documented in the README.md. If you make a change to the `ktweak` script, update the README.md documentation accordingly to keep end-users aware of the changes.
* All changes must be backed by logic or evidence. It is best to include benchmarks in your results, however this cannot always be expected (margin of error, unpredictable events, etc). Just ensure to read up on the documentation of the tunable and make sure your change makes sense. Other contributors can critique your tweak choice to fact-check it, as well.

## Contributor Responsibilities
Project maintainers should strive to keep KTweak genuine and free of the common mistakes made by other device tweaking modules (see the README.md). This includes regularly scanning recent issues and pull requests for both beneficial and detrimental changes and fact checking them.

Maintainers may also approve or reject pull requests, close and review issues, and perform other miscellaneous regulations that are deemed necessary.
